// Auto-generated. Do not edit!

// (in-package rail_manipulation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class MoveToPoseGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.planningTime = null;
      this.jointStateDifference = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('planningTime')) {
        this.planningTime = initObj.planningTime
      }
      else {
        this.planningTime = 0.0;
      }
      if (initObj.hasOwnProperty('jointStateDifference')) {
        this.jointStateDifference = initObj.jointStateDifference
      }
      else {
        this.jointStateDifference = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MoveToPoseGoal
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [planningTime]
    bufferOffset = _serializer.float32(obj.planningTime, buffer, bufferOffset);
    // Serialize message field [jointStateDifference]
    bufferOffset = _serializer.float64(obj.jointStateDifference, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MoveToPoseGoal
    let len;
    let data = new MoveToPoseGoal(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [planningTime]
    data.planningTime = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [jointStateDifference]
    data.jointStateDifference = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rail_manipulation_msgs/MoveToPoseGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '884ac5e0a74a1525f80333a77a4292d7';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    geometry_msgs/PoseStamped pose   # End-effector pose goal for planning
    float32 planningTime      # Maximum planning time, defaults to 5 seconds if unset
    float64 jointStateDifference   # Maximum difference in joint angles allowed between start and goal pose
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MoveToPoseGoal(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.planningTime !== undefined) {
      resolved.planningTime = msg.planningTime;
    }
    else {
      resolved.planningTime = 0.0
    }

    if (msg.jointStateDifference !== undefined) {
      resolved.jointStateDifference = msg.jointStateDifference;
    }
    else {
      resolved.jointStateDifference = 0.0
    }

    return resolved;
    }
};

module.exports = MoveToPoseGoal;
