// Auto-generated. Do not edit!

// (in-package rail_manipulation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class PickupGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.lift = null;
      this.verify = null;
      this.attachObject = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('lift')) {
        this.lift = initObj.lift
      }
      else {
        this.lift = false;
      }
      if (initObj.hasOwnProperty('verify')) {
        this.verify = initObj.verify
      }
      else {
        this.verify = false;
      }
      if (initObj.hasOwnProperty('attachObject')) {
        this.attachObject = initObj.attachObject
      }
      else {
        this.attachObject = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PickupGoal
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [lift]
    bufferOffset = _serializer.bool(obj.lift, buffer, bufferOffset);
    // Serialize message field [verify]
    bufferOffset = _serializer.bool(obj.verify, buffer, bufferOffset);
    // Serialize message field [attachObject]
    bufferOffset = _serializer.bool(obj.attachObject, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PickupGoal
    let len;
    let data = new PickupGoal(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [lift]
    data.lift = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [verify]
    data.verify = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [attachObject]
    data.attachObject = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    return length + 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rail_manipulation_msgs/PickupGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b467a263b60f190ed0408dd61d5a614a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    geometry_msgs/PoseStamped pose  # End-effector pickup pose
    bool lift                       # Flag for arm lifting after pickup
    bool verify                     # Flag for grasp verification after gripper close/lift
    bool attachObject               # Flag for whether or not the picked up object should be attached to the gripper
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PickupGoal(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.lift !== undefined) {
      resolved.lift = msg.lift;
    }
    else {
      resolved.lift = false
    }

    if (msg.verify !== undefined) {
      resolved.verify = msg.verify;
    }
    else {
      resolved.verify = false
    }

    if (msg.attachObject !== undefined) {
      resolved.attachObject = msg.attachObject;
    }
    else {
      resolved.attachObject = false
    }

    return resolved;
    }
};

module.exports = PickupGoal;
