// Auto-generated. Do not edit!

// (in-package rail_manipulation_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SegmentedObjectList = require('../msg/SegmentedObjectList.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class ProcessSegmentedObjectsRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.segmented_objects = null;
    }
    else {
      if (initObj.hasOwnProperty('segmented_objects')) {
        this.segmented_objects = initObj.segmented_objects
      }
      else {
        this.segmented_objects = new SegmentedObjectList();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcessSegmentedObjectsRequest
    // Serialize message field [segmented_objects]
    bufferOffset = SegmentedObjectList.serialize(obj.segmented_objects, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcessSegmentedObjectsRequest
    let len;
    let data = new ProcessSegmentedObjectsRequest(null);
    // Deserialize message field [segmented_objects]
    data.segmented_objects = SegmentedObjectList.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += SegmentedObjectList.getMessageSize(object.segmented_objects);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rail_manipulation_msgs/ProcessSegmentedObjectsRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '924369697b1d59bf060481bc93dca47a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    rail_manipulation_msgs/SegmentedObjectList segmented_objects
    
    ================================================================================
    MSG: rail_manipulation_msgs/SegmentedObjectList
    Header header              # Contains timestamp information for the most recent update to the object list
    bool cleared               # A flag indicating this message is the result of a clear instead of a segment
    SegmentedObject[] objects  # The list of segmented objects
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: rail_manipulation_msgs/SegmentedObject
    sensor_msgs/PointCloud2 point_cloud                     # Segmented point cloud
    sensor_msgs/Image image                                 # Segmented RGB image
    geometry_msgs/Point centroid                            # Centroid of the point cloud
    geometry_msgs/Point center                              # Center of the point cloud
    rail_manipulation_msgs/BoundingVolume bounding_volume   # minimum bounding rectangular prism
    float64 width                                           # The width of the object in meters (x in point cloud frame)
    float64 depth                                           # The depth of the object in meters (y in point cloud frame)
    float64 height                                          # The height of the object in meters (z in point cloud frame)
    float32[] rgb                                           # Average color in RGB color space
    float32[] cielab                                        # Average color in CIELAB color space
    geometry_msgs/Quaternion orientation                    # Orientation of the object (typically from object rec)
    bool recognized                                         # True if the object is recognized
    string name                                             # Object name (if recognized)
    uint32 model_id                                         # Object model ID (if recognized)
    float64 confidence                                      # Recognition confidence value
    Grasp[] grasps                                          # List of grasps (if recognized)
    visualization_msgs/Marker marker                        # The downsampled visualization of the object
    int32[] image_indices                                  # Indices of the segmented points in the 2D image coordinate
    
    ================================================================================
    MSG: sensor_msgs/PointCloud2
    # This message holds a collection of N-dimensional points, which may
    # contain additional information such as normals, intensity, etc. The
    # point data is stored as a binary blob, its layout described by the
    # contents of the "fields" array.
    
    # The point cloud data may be organized 2d (image-like) or 1d
    # (unordered). Point clouds organized as 2d images may be produced by
    # camera depth sensors such as stereo or time-of-flight.
    
    # Time of sensor data acquisition, and the coordinate frame ID (for 3d
    # points).
    Header header
    
    # 2D structure of the point cloud. If the cloud is unordered, height is
    # 1 and width is the length of the point cloud.
    uint32 height
    uint32 width
    
    # Describes the channels and their layout in the binary data blob.
    PointField[] fields
    
    bool    is_bigendian # Is this data bigendian?
    uint32  point_step   # Length of a point in bytes
    uint32  row_step     # Length of a row in bytes
    uint8[] data         # Actual point data, size is (row_step*height)
    
    bool is_dense        # True if there are no invalid points
    
    ================================================================================
    MSG: sensor_msgs/PointField
    # This message holds the description of one point entry in the
    # PointCloud2 message format.
    uint8 INT8    = 1
    uint8 UINT8   = 2
    uint8 INT16   = 3
    uint8 UINT16  = 4
    uint8 INT32   = 5
    uint8 UINT32  = 6
    uint8 FLOAT32 = 7
    uint8 FLOAT64 = 8
    
    string name      # Name of field
    uint32 offset    # Offset from start of point struct
    uint8  datatype  # Datatype enumeration, see above
    uint32 count     # How many elements in the field
    
    ================================================================================
    MSG: sensor_msgs/Image
    # This message contains an uncompressed image
    # (0, 0) is at top-left corner of image
    #
    
    Header header        # Header timestamp should be acquisition time of image
                         # Header frame_id should be optical frame of camera
                         # origin of frame should be optical center of camera
                         # +x should point to the right in the image
                         # +y should point down in the image
                         # +z should point into to plane of the image
                         # If the frame_id here and the frame_id of the CameraInfo
                         # message associated with the image conflict
                         # the behavior is undefined
    
    uint32 height         # image height, that is, number of rows
    uint32 width          # image width, that is, number of columns
    
    # The legal values for encoding are in file src/image_encodings.cpp
    # If you want to standardize a new string format, join
    # ros-users@lists.sourceforge.net and send an email proposing a new encoding.
    
    string encoding       # Encoding of pixels -- channel meaning, ordering, size
                          # taken from the list of strings in include/sensor_msgs/image_encodings.h
    
    uint8 is_bigendian    # is this data bigendian?
    uint32 step           # Full row length in bytes
    uint8[] data          # actual matrix data, size is (step * rows)
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rail_manipulation_msgs/BoundingVolume
    geometry_msgs/PoseStamped pose   # bounding volume pose (with respect to point cloud center)
    geometry_msgs/Vector3 dimensions # x, y, z dimensions (with respect to coordinate frame and rotation defined in pose)
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: rail_manipulation_msgs/Grasp
    geometry_msgs/PoseStamped grasp_pose  # The grasp pose
    string eef_frame_id                   # The coordinate frame of the end-effector used by this grasp
    uint32 grasp_id
    uint32 successes                      # The number of recorded times this grasp was successful (useful for success rate)
    uint32 attempts                       # The number of recorded times this grasp was attempted (useful for success rate)
    
    ================================================================================
    MSG: visualization_msgs/Marker
    # See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz
    
    uint8 ARROW=0
    uint8 CUBE=1
    uint8 SPHERE=2
    uint8 CYLINDER=3
    uint8 LINE_STRIP=4
    uint8 LINE_LIST=5
    uint8 CUBE_LIST=6
    uint8 SPHERE_LIST=7
    uint8 POINTS=8
    uint8 TEXT_VIEW_FACING=9
    uint8 MESH_RESOURCE=10
    uint8 TRIANGLE_LIST=11
    
    uint8 ADD=0
    uint8 MODIFY=0
    uint8 DELETE=2
    uint8 DELETEALL=3
    
    Header header                        # header for time/frame information
    string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
    int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
    int32 type 		                       # Type of object
    int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object, 3 deletes all objects
    geometry_msgs/Pose pose                 # Pose of the object
    geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
    std_msgs/ColorRGBA color             # Color [0.0-1.0]
    duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
    bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep
    
    #Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
    geometry_msgs/Point[] points
    #Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
    #number of colors must either be 0 or equal to the number of points
    #NOTE: alpha is not yet used
    std_msgs/ColorRGBA[] colors
    
    # NOTE: only used for text markers
    string text
    
    # NOTE: only used for MESH_RESOURCE markers
    string mesh_resource
    bool mesh_use_embedded_materials
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcessSegmentedObjectsRequest(null);
    if (msg.segmented_objects !== undefined) {
      resolved.segmented_objects = SegmentedObjectList.Resolve(msg.segmented_objects)
    }
    else {
      resolved.segmented_objects = new SegmentedObjectList()
    }

    return resolved;
    }
};

class ProcessSegmentedObjectsResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.segmented_objects = null;
    }
    else {
      if (initObj.hasOwnProperty('segmented_objects')) {
        this.segmented_objects = initObj.segmented_objects
      }
      else {
        this.segmented_objects = new SegmentedObjectList();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcessSegmentedObjectsResponse
    // Serialize message field [segmented_objects]
    bufferOffset = SegmentedObjectList.serialize(obj.segmented_objects, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcessSegmentedObjectsResponse
    let len;
    let data = new ProcessSegmentedObjectsResponse(null);
    // Deserialize message field [segmented_objects]
    data.segmented_objects = SegmentedObjectList.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += SegmentedObjectList.getMessageSize(object.segmented_objects);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rail_manipulation_msgs/ProcessSegmentedObjectsResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '924369697b1d59bf060481bc93dca47a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    rail_manipulation_msgs/SegmentedObjectList segmented_objects
    
    ================================================================================
    MSG: rail_manipulation_msgs/SegmentedObjectList
    Header header              # Contains timestamp information for the most recent update to the object list
    bool cleared               # A flag indicating this message is the result of a clear instead of a segment
    SegmentedObject[] objects  # The list of segmented objects
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: rail_manipulation_msgs/SegmentedObject
    sensor_msgs/PointCloud2 point_cloud                     # Segmented point cloud
    sensor_msgs/Image image                                 # Segmented RGB image
    geometry_msgs/Point centroid                            # Centroid of the point cloud
    geometry_msgs/Point center                              # Center of the point cloud
    rail_manipulation_msgs/BoundingVolume bounding_volume   # minimum bounding rectangular prism
    float64 width                                           # The width of the object in meters (x in point cloud frame)
    float64 depth                                           # The depth of the object in meters (y in point cloud frame)
    float64 height                                          # The height of the object in meters (z in point cloud frame)
    float32[] rgb                                           # Average color in RGB color space
    float32[] cielab                                        # Average color in CIELAB color space
    geometry_msgs/Quaternion orientation                    # Orientation of the object (typically from object rec)
    bool recognized                                         # True if the object is recognized
    string name                                             # Object name (if recognized)
    uint32 model_id                                         # Object model ID (if recognized)
    float64 confidence                                      # Recognition confidence value
    Grasp[] grasps                                          # List of grasps (if recognized)
    visualization_msgs/Marker marker                        # The downsampled visualization of the object
    int32[] image_indices                                  # Indices of the segmented points in the 2D image coordinate
    
    ================================================================================
    MSG: sensor_msgs/PointCloud2
    # This message holds a collection of N-dimensional points, which may
    # contain additional information such as normals, intensity, etc. The
    # point data is stored as a binary blob, its layout described by the
    # contents of the "fields" array.
    
    # The point cloud data may be organized 2d (image-like) or 1d
    # (unordered). Point clouds organized as 2d images may be produced by
    # camera depth sensors such as stereo or time-of-flight.
    
    # Time of sensor data acquisition, and the coordinate frame ID (for 3d
    # points).
    Header header
    
    # 2D structure of the point cloud. If the cloud is unordered, height is
    # 1 and width is the length of the point cloud.
    uint32 height
    uint32 width
    
    # Describes the channels and their layout in the binary data blob.
    PointField[] fields
    
    bool    is_bigendian # Is this data bigendian?
    uint32  point_step   # Length of a point in bytes
    uint32  row_step     # Length of a row in bytes
    uint8[] data         # Actual point data, size is (row_step*height)
    
    bool is_dense        # True if there are no invalid points
    
    ================================================================================
    MSG: sensor_msgs/PointField
    # This message holds the description of one point entry in the
    # PointCloud2 message format.
    uint8 INT8    = 1
    uint8 UINT8   = 2
    uint8 INT16   = 3
    uint8 UINT16  = 4
    uint8 INT32   = 5
    uint8 UINT32  = 6
    uint8 FLOAT32 = 7
    uint8 FLOAT64 = 8
    
    string name      # Name of field
    uint32 offset    # Offset from start of point struct
    uint8  datatype  # Datatype enumeration, see above
    uint32 count     # How many elements in the field
    
    ================================================================================
    MSG: sensor_msgs/Image
    # This message contains an uncompressed image
    # (0, 0) is at top-left corner of image
    #
    
    Header header        # Header timestamp should be acquisition time of image
                         # Header frame_id should be optical frame of camera
                         # origin of frame should be optical center of camera
                         # +x should point to the right in the image
                         # +y should point down in the image
                         # +z should point into to plane of the image
                         # If the frame_id here and the frame_id of the CameraInfo
                         # message associated with the image conflict
                         # the behavior is undefined
    
    uint32 height         # image height, that is, number of rows
    uint32 width          # image width, that is, number of columns
    
    # The legal values for encoding are in file src/image_encodings.cpp
    # If you want to standardize a new string format, join
    # ros-users@lists.sourceforge.net and send an email proposing a new encoding.
    
    string encoding       # Encoding of pixels -- channel meaning, ordering, size
                          # taken from the list of strings in include/sensor_msgs/image_encodings.h
    
    uint8 is_bigendian    # is this data bigendian?
    uint32 step           # Full row length in bytes
    uint8[] data          # actual matrix data, size is (step * rows)
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rail_manipulation_msgs/BoundingVolume
    geometry_msgs/PoseStamped pose   # bounding volume pose (with respect to point cloud center)
    geometry_msgs/Vector3 dimensions # x, y, z dimensions (with respect to coordinate frame and rotation defined in pose)
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: rail_manipulation_msgs/Grasp
    geometry_msgs/PoseStamped grasp_pose  # The grasp pose
    string eef_frame_id                   # The coordinate frame of the end-effector used by this grasp
    uint32 grasp_id
    uint32 successes                      # The number of recorded times this grasp was successful (useful for success rate)
    uint32 attempts                       # The number of recorded times this grasp was attempted (useful for success rate)
    
    ================================================================================
    MSG: visualization_msgs/Marker
    # See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz
    
    uint8 ARROW=0
    uint8 CUBE=1
    uint8 SPHERE=2
    uint8 CYLINDER=3
    uint8 LINE_STRIP=4
    uint8 LINE_LIST=5
    uint8 CUBE_LIST=6
    uint8 SPHERE_LIST=7
    uint8 POINTS=8
    uint8 TEXT_VIEW_FACING=9
    uint8 MESH_RESOURCE=10
    uint8 TRIANGLE_LIST=11
    
    uint8 ADD=0
    uint8 MODIFY=0
    uint8 DELETE=2
    uint8 DELETEALL=3
    
    Header header                        # header for time/frame information
    string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
    int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
    int32 type 		                       # Type of object
    int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object, 3 deletes all objects
    geometry_msgs/Pose pose                 # Pose of the object
    geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
    std_msgs/ColorRGBA color             # Color [0.0-1.0]
    duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
    bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep
    
    #Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
    geometry_msgs/Point[] points
    #Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
    #number of colors must either be 0 or equal to the number of points
    #NOTE: alpha is not yet used
    std_msgs/ColorRGBA[] colors
    
    # NOTE: only used for text markers
    string text
    
    # NOTE: only used for MESH_RESOURCE markers
    string mesh_resource
    bool mesh_use_embedded_materials
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcessSegmentedObjectsResponse(null);
    if (msg.segmented_objects !== undefined) {
      resolved.segmented_objects = SegmentedObjectList.Resolve(msg.segmented_objects)
    }
    else {
      resolved.segmented_objects = new SegmentedObjectList()
    }

    return resolved;
    }
};

module.exports = {
  Request: ProcessSegmentedObjectsRequest,
  Response: ProcessSegmentedObjectsResponse,
  md5sum() { return '9087dd6d41640e91495dd2e88006db15'; },
  datatype() { return 'rail_manipulation_msgs/ProcessSegmentedObjects'; }
};
